=== debian/changelog ===
intel-ipsec-mb (0.48-4) unstable; urgency=medium

  * Add manpage and update README (LP: #1756175)
    - upstream commits a544139781f6cb12 and 4a8557cec413933b

 -- Colin Ian King <colin.king@canonical.com>  Thu, 15 Mar 2018 18:59:42 +0000

intel-ipsec-mb (0.48-3) unstable; urgency=medium

  * disable stack execution flag in shared library file (LP: #1754996)
    - upstream commit 94f3ebb21e09e992 ("Fix for issue #18 to disable
      stack execution flag in ELF shared library file")

 -- Colin Ian King <colin.king@canonical.com>  Sun, 11 Mar 2018 15:38:11 +0000

intel-ipsec-mb (0.48-2) unstable; urgency=medium

  * Add in some latest upstream updates:
    - AES-CMAC-128 and AES-CMAC-96 authentication support
    - Year update in copyrights
    - Added option to ipsec_perf to affinitize threads to cores
    - Library gets compiled to SO/DLL by default
    - Re-enable static library build to override default SO library build
      so both are now built

 -- Colin Ian King <colin.king@canonical.com>  Thu, 1 Mar 2018 13:42:57 +0000

intel-ipsec-mb (0.48-1) unstable; urgency=medium

  * Initial debian version (Closes: #890519)
  * Add in extra functionality and fixes since 0.48-1 release:
    - DES cipher added to LibPerfApp. Library version bump.
    - AVX512 DES improvement to smooth out performance 'stairs'
    - Fix for issue #16 (seg fault using HMAC-SHA512 or
      HMAC-SHA384 on AVX2)
    - 3DES support
    - AVX512 version of 3DES

 -- Colin Ian King <colin.king@canonical.com>  Thu, 15 Feb 2018 10:34:15 +0000
