## intel-ipsec-mb 0.50

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2012-2017, Intel Corporation
+# Copyright (c) 2012-2018, Intel Corporation
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -12,7 +12,7 @@
 #     * Neither the name of Intel Corporation nor the names of its contributors
 #       may be used to endorse or promote products derived from this software
 #       without specific prior written permission.
-# 
+#
 # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 # AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
@@ -24,10 +24,27 @@
 # OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 #
+
 LIB = libIPSec_MB
-VERSION = 0.48
-SO_VERSION = 0
-SHARED ?= n
+SHARED ?= y
+IMB_HDR = intel-ipsec-mb.h
+
+# Detect library version
+IMB_VERSION = $(shell grep -e "IMB_VERSION_STR" $(IMB_HDR) | cut -d'"' -f2)
+ifeq ($(IMB_VERSION),)
+$(error "Failed to detect library version!")
+endif
+
+VERSION = $(shell echo $(IMB_VERSION) | cut -d. -f1-2)
+SO_VERSION = $(shell echo $(VERSION) | cut -d. -f1)
+
+PREFIX ?= /usr
+LIB_INSTALL_DIR ?= $(PREFIX)/lib
+HDR_DIR ?= $(PREFIX)/include
+MAN_DIR ?= $(PREFIX)/man/man7
+MAN1 = libipsec-mb.7
+MAN2 = libipsec-mb-dev.7
+NOLDCONFIG ?= n
 
 USE_YASM ?= n
 YASM ?= yasm
@@ -104,6 +121,7 @@
 	aes_keyexp_256.o \
 	aes_xcbc_mac_128_x4.o \
 	aes_xcbc_mac_128_x8.o \
+	aes_cmac_subkey_gen.o \
 	mb_mgr_aes192_flush_avx.o \
 	mb_mgr_aes192_flush_sse.o \
 	mb_mgr_aes192_submit_avx.o \
@@ -203,14 +221,18 @@
 	sha_256_mult_sse.o \
 	\
 	aes_xcbc_expand_key.o \
+	alloc.o \
 	mb_mgr_avx.o \
 	mb_mgr_avx2.o \
 	mb_mgr_avx512.o \
 	mb_mgr_sse.o \
 	md5_one_block.o \
+	sha_one_block.o \
 	des_key.o \
 	des_basic.o \
-	des_x16_avx512.o
+	des_x16_avx512.o \
+	const.o \
+	version.o
 
 gcm_objs := gcm128_sse.o gcm192_sse.o gcm256_sse.o \
 	gcm128_avx_gen2.o gcm192_avx_gen2.o gcm256_avx_gen2.o \
@@ -231,15 +253,44 @@
 	ln -f -s $(LIBNAME) $(LIB).so.$(SO_VERSION)
 	ln -f -s $(LIB).so.$(SO_VERSION) $(LIB).so
 else
-	ar -qcs $@ $^
-endif
+	$(AR) -qcs $@ $^
+endif
+
+.PHONY: install
+install: $(LIBNAME)
+	install -d $(HDR_DIR)
+	install -m 0644 $(IMB_HDR) $(HDR_DIR)
+	install -d $(LIB_INSTALL_DIR)
+	install -s -m $(LIBPERM) $(LIBNAME) $(LIB_INSTALL_DIR)
+	install -d $(MAN_DIR)
+	install -m 0444 $(MAN1) $(MAN_DIR)
+	install -m 0444 $(MAN2) $(MAN_DIR)
+ifeq ($(SHARED),y)
+	cd $(LIB_INSTALL_DIR); \
+		ln -f -s $(LIB).so.$(VERSION) $(LIB).so.$(SO_VERSION); \
+		ln -f -s $(LIB).so.$(SO_VERSION) $(LIB).so
+ifneq ($(NOLDCONFIG),y)
+	ldconfig
+endif
+endif
+
+.PHONY: uninstall
+uninstall: $(LIBNAME)
+	-rm -f $(HDR_DIR)/$(IMB_HDR)
+	-rm -f $(LIB_INSTALL_DIR)/$(LIBNAME)
+	-rm -f $(MAN_DIR)/$(MAN1)
+	-rm -f $(MAN_DIR)/$(MAN2)
+ifeq ($(SHARED),y)
+	-rm -f $(LIB_INSTALL_DIR)/$(LIB).so.$(SO_VERSION)
+	-rm -f $(LIB_INSTALL_DIR)/$(LIB).so
+endif
+
 
 $(obj2_files): | $(OBJ_DIR)
 
 $(OBJ_DIR)/%.o:%.c
 	@ echo "Making object file $@ "
 	$(CC) -c $(CFLAGS) $< -o $@
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:%.asm
 	@ echo "Making object file $@ "
@@ -248,12 +299,10 @@
 else
 	$(NASM) -o $@ $(NASM_FLAGS) $<
 endif
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:sse/%.c
 	@ echo "Making object file $@ "
 	$(CC) -c $(CFLAGS) $< -o $@
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:sse/%.asm
 	@ echo "Making object file $@ "
@@ -262,12 +311,10 @@
 else
 	$(NASM) -o $@ $(NASM_FLAGS) $<
 endif
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:avx/%.c
 	@ echo "Making object file $@ "
 	$(CC) -c $(CFLAGS) $< -o $@
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:avx/%.asm
 	@ echo "Making object file $@ "
@@ -276,12 +323,10 @@
 else
 	$(NASM) -o $@ $(NASM_FLAGS) $<
 endif
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:avx2/%.c
 	@ echo "Making object file $@ "
 	$(CC) -c $(CFLAGS) $< -o $@
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:avx2/%.asm
 	@ echo "Making object file $@ "
@@ -290,12 +335,10 @@
 else
 	$(NASM) -o $@ $(NASM_FLAGS) $<
 endif
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:avx512/%.c
 	@ echo "Making object file $@ "
 	$(CC) -c $(CFLAGS) $< -o $@
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:avx512/%.asm
 	@ echo "Making object file $@ "
@@ -304,7 +347,6 @@
 else
 	$(NASM) -o $@ $(NASM_FLAGS) $<
 endif
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR)/%.o:include/%.asm
 	@ echo "Making object file $@ "
@@ -313,7 +355,6 @@
 else
 	$(NASM) -o $@ $(NASM_FLAGS) $<
 endif
-	@ echo "--------------------------------------------------------------"
 
 $(OBJ_DIR):
 	mkdir $(OBJ_DIR)
@@ -347,4 +388,3 @@
 UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,\
 NEW_TYPEDEFS,AVOID_EXTERNS,COMPLEX_MACRO,PREFER_ALIGNED,USE_FUNC,\
 CONSTANT_COMPARISON,SPACING $(SOURCES_STYLE)
-
