=== LibTestApp/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (c) 2012-2017, Intel Corporation
+# Copyright (c) 2012-2018, Intel Corporation
 #
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
@@ -26,11 +26,26 @@
 #
 
 APP := ipsec_MB_testapp
+INSTPATH ?= /usr/include/intel-ipsec-mb.h
 
-LIBDIR ?= ../
-LDFLAGS = -L$(LIBDIR) -fPIE -z noexecstack -z relro -z now
+CFLAGS = -g -DLINUX -D_GNU_SOURCE \
+	-W -Wall -Wextra -Wmissing-declarations -Wpointer-arith \
+	-Wcast-qual -Wundef -Wwrite-strings  \
+	-Wformat -Wformat-security \
+	-Wunreachable-code -Wmissing-noreturn -Wsign-compare -Wno-endif-labels \
+	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition
+
+LDFLAGS = -fPIE -z noexecstack -z relro -z now
 LDLIBS = -lIPSec_MB
-CFLAGS = -g -DLINUX -I../include -I..
+
+ifeq ("$(shell test -r $(INSTPATH) && echo -n yes)","yes")
+# library installed
+CFLAGS +=
+else
+# library not installed
+CFLAGS +=  -I../include -I../
+LDFLAGS += -L../
+endif
 
 ifeq ($(DEBUG),y)
 CFLAGS += -O0 -DDEBUG
@@ -39,7 +54,9 @@
 CFLAGS += -O3
 endif
 
-SOURCES := main.c gcm_test.c ctr_test.c customop_test.c des_test.c ccm_test.c
+SOURCES := main.c gcm_test.c ctr_test.c customop_test.c des_test.c ccm_test.c \
+	cmac_test.c utils.c hmac_sha1_test.c hmac_sha256_sha512_test.c \
+	hmac_md5_test.c
 OBJECTS := $(SOURCES:%.c=%.o)
 
 all: $(APP)
@@ -51,8 +68,13 @@
 gcm_test.o: gcm_test.c gcm_ctr_vectors_test.h
 ctr_test.o: ctr_test.c gcm_ctr_vectors_test.h
 des_test.o: des_test.c
-ccm_test.o: ccm_test.c
+ccm_test.o: ccm_test.c utils.h
+cmac_test.o: cmac_test.c utils.h
+hmac_sha1_test.o: hmac_sha1_test.c utils.h
+hmac_md5_test.o: hmac_md5_test.c utils.h
+hmac_sha256_sha512_test.o: hmac_sha256_sha512_test.c utils.h
 customop_test.o: customop_test.c customop_test.h
+utils.o: utils.c utils.h
 
 .PHONY: clean
 clean:
@@ -62,7 +84,7 @@
 CHECKPATCH?=checkpatch.pl
 .PHONY: style
 style:
-	$(CHECKPATCH) --no-tree --no-signoff --emacs --no-color --max-line-length=100 \
+	$(CHECKPATCH) --no-tree --no-signoff --emacs --no-color \
 --ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE,SPLIT_STRING,\
 UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,\
 AVOID_EXTERNS,USE_FUNC,CONSTANT_COMPARISON $(SOURCES_STYLE)
