=== debian/changelog ===
intel-ipsec-mb (0.50-2) unstable; urgency=medium

  [ Dmitry Eremin-Solenikov ]
  * Install libraries and headers into system path (Closes: #896788)
    Note: The package name has been renamed from libipsec-mb to libipsec-mb0
  * Rename library package to follow soname
  * Use dh_installdocs to install LICENSE file.
  * Install README file.

 -- Colin Ian King <colin.king@canonical.com>  Fri, 13 Jul 2018 13:52:59 +0100

intel-ipsec-mb (0.50-1) unstable; urgency=medium

  * Sync to latest 0.50 release
  * Add fix to disable stack execution flag in const.asm

 -- Colin Ian King <colin.king@canonical.com>  Tue, 3 Jul 2018 10:40:53 +0100

intel-ipsec-mb (0.49-1) unstable; urgency=medium

  * Sync to latest 0.49 release, drop debian/patches that are
    no longer required

 -- Colin Ian King <colin.king@canonical.com>  Tue, 3 Apr 2018 14:24:59 +0100
