## intel-ipsec-mb 0.52

=== Makefile ===
--- 
+++ 
@@ -52,7 +52,7 @@
 
 OBJ_DIR = obj
 
-INCLUDE_DIRS := include .
+INCLUDE_DIRS := include . no-aesni
 INCLUDES := $(foreach i,$(INCLUDE_DIRS),-I $i)
 
 CC ?= gcc
@@ -65,10 +65,28 @@
 	-Wstrict-prototypes -Wmissing-prototypes -Wold-style-definition
 
 ifeq ($(DEBUG),y)
-CFLAGS += -g -O0 -DDEBUG
+CFLAGS += -g -DDEBUG
+OPT = -O0
 LDFLAGS += -g
 else
-CFLAGS += -O3 -fstack-protector -D_FORTIFY_SOURCE=2
+OPT = -O3
+CFLAGS += -fstack-protector -D_FORTIFY_SOURCE=2
+endif
+
+# prevent SIMD optimizations for non-aesni modules
+CFLAGS_NO_SIMD = $(CFLAGS) -O1
+CFLAGS += $(OPT)
+
+# Set architectural optimizations for GCC/CC
+ifeq ($(CC),$(filter $(CC),gcc cc))
+GCC_VERSION = $(shell $(CC) -dumpversion | cut -d. -f1)
+GCC_GE_V5 = $(shell [ $(GCC_VERSION) -ge 5 ] && echo true)
+ifeq ($(GCC_GE_V5),true)
+OPT_SSE = -march=nehalem
+OPT_AVX = -march=sandybridge
+OPT_AVX2 = -march=haswell
+OPT_AVX512 = -march=broadwell
+endif
 endif
 
 # so or static build
@@ -94,50 +112,73 @@
 
 lib_objs := \
 	aes128_cbc_dec_by4_sse.o \
+	aes128_cbc_dec_by4_sse_no_aesni.o \
 	aes128_cbc_dec_by8_avx.o \
 	aes128_cntr_by4_sse.o \
+	aes128_cntr_by4_sse_no_aesni.o \
 	aes128_cntr_by8_avx.o \
 	aes128_ecbenc_x3.o \
 	aes192_cbc_dec_by4_sse.o \
+	aes192_cbc_dec_by4_sse_no_aesni.o \
 	aes192_cbc_dec_by8_avx.o \
 	aes192_cntr_by4_sse.o \
+	aes192_cntr_by4_sse_no_aesni.o \
 	aes192_cntr_by8_avx.o \
 	aes256_cbc_dec_by4_sse.o \
+	aes256_cbc_dec_by4_sse_no_aesni.o \
 	aes256_cbc_dec_by8_avx.o \
 	aes256_cntr_by4_sse.o \
+	aes256_cntr_by4_sse_no_aesni.o \
 	aes256_cntr_by8_avx.o \
 	aes_cfb_128_sse.o \
+	aes_cfb_128_sse_no_aesni.o \
 	aes_cfb_128_avx.o \
 	aes128_cbc_mac_x4.o \
+	aes128_cbc_mac_x4_no_aesni.o \
 	aes128_cbc_mac_x8.o \
 	aes_cbc_enc_128_x4.o \
+	aes_cbc_enc_128_x4_no_aesni.o \
 	aes_cbc_enc_128_x8.o \
 	aes_cbc_enc_192_x4.o \
+	aes_cbc_enc_192_x4_no_aesni.o \
 	aes_cbc_enc_192_x8.o \
 	aes_cbc_enc_256_x4.o \
+	aes_cbc_enc_256_x4_no_aesni.o \
 	aes_cbc_enc_256_x8.o \
 	aes_keyexp_128.o \
 	aes_keyexp_192.o \
 	aes_keyexp_256.o \
 	aes_xcbc_mac_128_x4.o \
+	aes_xcbc_mac_128_x4_no_aesni.o \
 	aes_xcbc_mac_128_x8.o \
 	aes_cmac_subkey_gen.o \
 	mb_mgr_aes192_flush_avx.o \
 	mb_mgr_aes192_flush_sse.o \
+	mb_mgr_aes192_flush_sse_no_aesni.o \
 	mb_mgr_aes192_submit_avx.o \
 	mb_mgr_aes192_submit_sse.o \
+	mb_mgr_aes192_submit_sse_no_aesni.o \
 	mb_mgr_aes256_flush_avx.o \
 	mb_mgr_aes256_flush_sse.o \
+	mb_mgr_aes256_flush_sse_no_aesni.o \
 	mb_mgr_aes256_submit_avx.o \
 	mb_mgr_aes256_submit_sse.o \
+	mb_mgr_aes256_submit_sse_no_aesni.o \
 	mb_mgr_aes_flush_avx.o \
 	mb_mgr_aes_flush_sse.o \
+	mb_mgr_aes_flush_sse_no_aesni.o \
 	mb_mgr_aes_submit_avx.o \
 	mb_mgr_aes_submit_sse.o \
+	mb_mgr_aes_submit_sse_no_aesni.o \
+	mb_mgr_aes_cmac_submit_flush_sse.o \
+	mb_mgr_aes_cmac_submit_flush_sse_no_aesni.o \
+	mb_mgr_aes_cmac_submit_flush_avx.o\
 	mb_mgr_aes_xcbc_flush_avx.o \
 	mb_mgr_aes_xcbc_flush_sse.o \
+	mb_mgr_aes_xcbc_flush_sse_no_aesni.o \
 	mb_mgr_aes_xcbc_submit_avx.o \
 	mb_mgr_aes_xcbc_submit_sse.o \
+	mb_mgr_aes_xcbc_submit_sse_no_aesni.o \
 	mb_mgr_hmac_flush_avx.o \
 	mb_mgr_hmac_flush_avx2.o \
 	mb_mgr_hmac_flush_sse.o \
@@ -219,24 +260,29 @@
 	sha512_x8_avx512.o \
 	sha_256_mult_avx.o \
 	sha_256_mult_sse.o \
-	\
 	aes_xcbc_expand_key.o \
 	alloc.o \
 	mb_mgr_avx.o \
 	mb_mgr_avx2.o \
 	mb_mgr_avx512.o \
 	mb_mgr_sse.o \
+	mb_mgr_sse_no_aesni.o \
 	md5_one_block.o \
 	sha_one_block.o \
 	des_key.o \
 	des_basic.o \
 	des_x16_avx512.o \
 	const.o \
-	version.o
-
-gcm_objs := gcm128_sse.o gcm192_sse.o gcm256_sse.o \
+	version.o \
+	cpu_feature.o \
+	aesni_emu.o
+
+gcm_objs := gcm.o gcm128_sse.o gcm192_sse.o gcm256_sse.o \
 	gcm128_avx_gen2.o gcm192_avx_gen2.o gcm256_avx_gen2.o \
-	gcm128_avx_gen4.o gcm192_avx_gen4.o gcm256_avx_gen4.o
+	gcm128_avx_gen4.o gcm192_avx_gen4.o gcm256_avx_gen4.o \
+	gcm128_sse_no_aesni.o gcm192_sse_no_aesni.o gcm256_sse_no_aesni.o \
+	gcm128_vaes_avx512.o gcm192_vaes_avx512.o gcm256_vaes_avx512.o \
+	gcm128_avx512.o gcm192_avx512.o gcm256_avx512.o
 
 ifeq ($(NO_GCM), y)
 obj2_files := $(lib_objs:%=$(OBJ_DIR)/%)
@@ -289,11 +335,9 @@
 $(obj2_files): | $(OBJ_DIR)
 
 $(OBJ_DIR)/%.o:%.c
-	@ echo "Making object file $@ "
 	$(CC) -c $(CFLAGS) $< -o $@
 
 $(OBJ_DIR)/%.o:%.asm
-	@ echo "Making object file $@ "
 ifeq ($(USE_YASM),y)
 	$(YASM) $(YASM_FLAGS) $< -o $@
 else
@@ -301,11 +345,9 @@
 endif
 
 $(OBJ_DIR)/%.o:sse/%.c
-	@ echo "Making object file $@ "
-	$(CC) -c $(CFLAGS) $< -o $@
+	$(CC) $(OPT_SSE) -c $(CFLAGS) $< -o $@
 
 $(OBJ_DIR)/%.o:sse/%.asm
-	@ echo "Making object file $@ "
 ifeq ($(USE_YASM),y)
 	$(YASM) $(YASM_FLAGS) $< -o $@
 else
@@ -313,11 +355,9 @@
 endif
 
 $(OBJ_DIR)/%.o:avx/%.c
-	@ echo "Making object file $@ "
-	$(CC) -c $(CFLAGS) $< -o $@
+	$(CC) $(OPT_AVX) -c $(CFLAGS) $< -o $@
 
 $(OBJ_DIR)/%.o:avx/%.asm
-	@ echo "Making object file $@ "
 ifeq ($(USE_YASM),y)
 	$(YASM) $(YASM_FLAGS) $< -o $@
 else
@@ -325,11 +365,9 @@
 endif
 
 $(OBJ_DIR)/%.o:avx2/%.c
-	@ echo "Making object file $@ "
-	$(CC) -c $(CFLAGS) $< -o $@
+	$(CC) $(OPT_AVX2) -c $(CFLAGS) $< -o $@
 
 $(OBJ_DIR)/%.o:avx2/%.asm
-	@ echo "Making object file $@ "
 ifeq ($(USE_YASM),y)
 	$(YASM) $(YASM_FLAGS) $< -o $@
 else
@@ -337,11 +375,9 @@
 endif
 
 $(OBJ_DIR)/%.o:avx512/%.c
-	@ echo "Making object file $@ "
-	$(CC) -c $(CFLAGS) $< -o $@
+	$(CC) $(OPT_AVX512) -c $(CFLAGS) $< -o $@
 
 $(OBJ_DIR)/%.o:avx512/%.asm
-	@ echo "Making object file $@ "
 ifeq ($(USE_YASM),y)
 	$(YASM) $(YASM_FLAGS) $< -o $@
 else
@@ -349,7 +385,16 @@
 endif
 
 $(OBJ_DIR)/%.o:include/%.asm
-	@ echo "Making object file $@ "
+ifeq ($(USE_YASM),y)
+	$(YASM) $(YASM_FLAGS) $< -o $@
+else
+	$(NASM) -o $@ $(NASM_FLAGS) $<
+endif
+
+$(OBJ_DIR)/%.o:no-aesni/%.c
+	$(CC) -c $(CFLAGS_NO_SIMD) $< -o $@
+
+$(OBJ_DIR)/%.o:no-aesni/%.asm
 ifeq ($(USE_YASM),y)
 	$(YASM) $(YASM_FLAGS) $< -o $@
 else
@@ -370,21 +415,15 @@
 	rm -Rf $(obj2_files)
 	rm -f $(LIB).a $(LIB).so*
 
-SOURCES_DIRS := . sse avx avx2 avx512 include
-SOURCES := $(foreach dir,$(SOURCES_DIRS),$(wildcard $(dir)/*.[ch]) $(wildcard $(dir)/*.asm) $(wildcard $(dir)/*.inc))
-SOURCES_STYLE := $(foreach infile,$(SOURCES),-f $(infile))
-CHECKPATCH?=checkpatch.pl
-# SPACING - produces false positives with tyepdefs and *
-# CONSTANT_COMPARISON - forbids defensive programming technique
-# USE_FUNC - produces false positives for Windows target
-# INITIALISED_STATIC, LEADING_SPACE, SPLIT_STRING, CODE_INDENT,
-# PREFER_ALIGNED, UNSPECIFIED_INT, ARRAY_SIZE, GLOBAL_INITIALISERS,
-# NEW_TYPEDEFS, AVOID_EXTERNS, COMPLEX_MACRO, BLOCK_COMMENT_STYLE
-# - found obsolete in this project
-.PHONY: style
-style:
-	$(CHECKPATCH) --no-tree --no-signoff --emacs --no-color \
---ignore CODE_INDENT,INITIALISED_STATIC,LEADING_SPACE,SPLIT_STRING,\
-UNSPECIFIED_INT,ARRAY_SIZE,BLOCK_COMMENT_STYLE,GLOBAL_INITIALISERS,\
-NEW_TYPEDEFS,AVOID_EXTERNS,COMPLEX_MACRO,PREFER_ALIGNED,USE_FUNC,\
-CONSTANT_COMPARISON,SPACING $(SOURCES_STYLE)
+CHECKPATCH ?= checkpatch.pl
+# checkpatch ignore settings:
+#   SPACING - produces false positives with tyepdefs and *
+#   CONSTANT_COMPARISON - forbids defensive programming technique
+#   USE_FUNC - produces false positives for Windows target
+#   INITIALISED_STATIC, LEADING_SPACE, SPLIT_STRING, CODE_INDENT,
+#   PREFER_ALIGNED, UNSPECIFIED_INT, ARRAY_SIZE, GLOBAL_INITIALISERS,
+#   NEW_TYPEDEFS, AVOID_EXTERNS, COMPLEX_MACRO, BLOCK_COMMENT_STYLE
+#     - found obsolete in this project
+#
+# NOTE: these flags cannot be broken into multiple lines due to
+#       spaces injected by make
