=== debian/changelog ===
intel-ipsec-mb (0.52-2) unstable; urgency=medium

  [ Luca Boccassi ]
  * Fix static library, don't strip (Closes: #918034)
  
 -- Colin Ian King <colin.king@canonical.com>  Wed, 2 Jan 2019 15:13:11 +0000

intel-ipsec-mb (0.52-1) unstable; urgency=medium

  * Sync to latest 0.52 release

 -- Colin Ian King <colin.king@canonical.com>  Thu, 20 Dec 2018 22:01:14 +0000

intel-ipsec-mb (0.51-1) unstable; urgency=medium

  * Sync to latest 0.51 release
  * Remove fix to disable stack execution flag in const.asm as this is now
    in 0.51

 -- Colin Ian King <colin.king@canonical.com>  Wed, 10 Oct 2018 13:01:11 +0100
