=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Standards-Version: 4.1.2
 Homepage: https://github.com/intel/intel-ipsec-mb
 
-Package: libipsec-mb
+Package: libipsec-mb0
 Section: libs
 Architecture: amd64
 Priority: optional
@@ -22,7 +22,7 @@
 Section: libdevel
 Architecture: linux-amd64
 Priority: optional
-Depends: ${misc:Depends}, libipsec-mb
+Depends: ${misc:Depends}, libipsec-mb0 (= ${binary:Version})
 Pre-Depends: ${misc:Pre-Depends}
 Description: Development files for Intel(R) Multi-Buffer Crypto for IPSec library
  Libipsec-mb is highly-optimized software implementations of
