=== debian/rules ===
--- 
+++ 
@@ -26,8 +26,8 @@
 override_dh_auto_install:
 	# Install the library
 	install -d ${DESTDIR}${LIBDIR}
-	install -m 0644 -s $$(pwd)/libIPSec_MB.a ${DESTDIR}${LIBDIR}
-	install -m 0644 -s $$(pwd)/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR} ${DESTDIR}${LIBDIR}
+	install -m 0644 $$(pwd)/libIPSec_MB.a ${DESTDIR}${LIBDIR}
+	install -m 0644 $$(pwd)/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR} ${DESTDIR}${LIBDIR}
 	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}.${VERSION_MINOR} ${DESTDIR}${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR}
 	ln -s ${LIBDIR}/libIPSec_MB.so.${VERSION_MAJOR} ${DESTDIR}${LIBDIR}/libIPSec_MB.so
